# Go2编程指南

- *KusonStack一站式可编程配置技术栈(Go): https://github.com/KusionStack/kusion*
- *KCL 配置编程语言(Rust): https://github.com/KusionStack/KCLVM*
- *凹语言™: https://github.com/wa-lang/wa*

----

本书重点讲解Go2新特性，以及Go1教程中较少涉及的特性。本书适合对Go语言有一定基础的用户学习。对于刚学习Go语言的读者，建议先从[《Go语言圣经》](https://github.com/golang-china/gopl-zh)开始系统学习Go语言的基础知识。如果希望了解Go语言CGO或汇编语言的细节，可以参考[《Go语言高级编程》](https://github.com/chai2010/advanced-go-programming-book)。如果希望深入学习Go语言语法树结构，可以参考[《Go语法树入门——开启自制编程语言和编译器之旅》](https://github.com/chai2010/go-ast-book)。

![](cover.png)

- 作者：柴树杉，Github [@chai2010](https://github.com/chai2010)，Twitter [@chaishushan](https://twitter.com/chaishushan)
- 网址：https://github.com/chai2010/go2-book
- Star历史：https://starcharts.herokuapp.com/chai2010/go2-book.svg

## 在线阅读

- [SUMMARY.md](SUMMARY.md)
- https://chai2010.cn/go2-book/


## 网易云课堂·光谷码农课堂

https://study.163.com/provider/480000001914454/index.htm


## 加入QQ群：102319854

中国最早的Go语言QQ群

## 关注微信公众号(光谷码农/guanggu-coder)

![](https://chai2010.cn/advanced-go-programming-book/weixin-guanggu-coder-logo.png)

加入微信群：从公众号底部菜单扫码进群。

## 相关报告

1. [GIAC: 2018 - Go 语言将要走向何方？(PDF)](https://chai2010.cn/static-public/talks/giac2018-go-talk.pdf) - [上海·GIAC全球互联网架构大会](http://2018.thegiac.com/detail.php?id=13467) 2018/11/23


## 版权声明

<a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://i.creativecommons.org/l/by-nc-nd/4.0/88x31.png" /></a><br /><span xmlns:dct="http://purl.org/dc/terms/" property="dct:title">Go2编程指南</span> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="https://github.com/chai2010/go2-book" property="cc:attributionName" rel="cc:attributionURL">柴树杉</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/4.0/">知识共享 署名-非商业性使用-禁止演绎 4.0 国际 许可协议</a>进行许可。

严禁任何商业行为使用或引用该文档的全部或部分内容！

欢迎大家提供建议！
